<div class="floating-toolbar-right">
  Toggle (hide/show):
  <button type="button" class="btn btn-primary btn-toggle-questions">Question text</button>
  <button type="button" class="btn btn-primary btn-toggle-answers">Correct answers</button>
  <button type="button" class="btn btn-primary btn-toggle-images">Inline images</button>
  <button type="button" class="btn btn-primary btn-toggle-docs">Inline docs</button>
  Hide:
  <button type="button" class="btn btn-primary btn-hide-graded">Hide graded</button>
</div>

<div class="container-fluid" style="padding: 30px">
  <% for (var i = 0; i < qs.length; ++i) { %>
  <div
    class="w-100 question-bundle"
    style="border: 2px dashed gray; border-radius: 5px; padding: 20px"
  >
    <div class="row" style="border-bottom: 2px dashed gray">
      <div class="col-sm-1">
        <h2><span class="badge badge-secondary"><%= (i+1) %>.</span></h2>
      </div>
      <div class="col-sm-1"><%- qs[i].imageUrl%></div>
      <div class="col-sm-8 col-sm-offset-1">
        <h3>
          <%= qs[i].alt_id2 %> <%= qs[i].last_name %>, <%= qs[i].first_name %> , question ordinal:
          <span class="badge badge-secondary"><%= qs[i].ordinal %>.</span> , question:
          <a href="/question/edit/<%-qs[i].id_question%>" target="_blank"
            ><%= qs[i].id_question %></a
          >
          ,
          <a href="/exam/review/<%-qs[i].id_test_instance%>/<%-qs[i].ordinal%>" target="_blank"
            >review</a
          >
        </h3>
      </div>
    </div>

    <% if (qs[i].questionCommentHtml && qs[i].questionCommentHtml.length > 1) { %>
    <div class="row question-row" style="border-bottom: 2px dashed gray; margin-bottom: 10px">
      <div class="col-sm-8 p-1 border border-deafult rounded"><%- qs[i].questionHtml %></div>
      <div class="col-sm-4 p-2 border border-deafult rounded"><%- qs[i].questionCommentHtml %></div>
    </div>
    <% } else { %>
    <div class="row question-row" style="border-bottom: 2px dashed gray; margin-bottom: 10px">
      <div class="col-sm-12 p-1 border border-deafult rounded"><%- qs[i].questionHtml %></div>
    </div>
    <% } %>

    <div class="row correct-answers-row">
      <div class="col-sm-6 p-1 border border-deafult rounded">
        <div class="row">
          <div class="col-12">
            <strong>
              Score: <%= qs[i].score %> (<%= qs[i].score_perc * 100 %>%) <%= qs[i].hint ? `Hint:
              ${qs[i].hint}` : '' %>
            </strong>
          </div>
          <% if (qs[i].c_eval_data) { %> <% const parsed = JSON.parse(qs[i].c_eval_data); %>
          <div class="col-12">
            <details open>
              <summary>Eval log</summary>
              <table>
                <tr>
                  <th>#</th>
                  <th>stdin</th>
                  <th>stdout</th>
                  <th>expected</th>
                  <th>stderr</th>
                  <th>percentage</th>
                  <th>hint</th>
                  <th>correct?</th>
                </tr>
                <% for (let idx = 0; idx < parsed.length; idx++) { %> <% let row = parsed[idx]; %>
                <tr>
                  <td><%= idx + 1 %></td>
                  <td class="edgar-code">
                    <pre><%= row.input %> </pre>
                  </td>
                  <td class="edgar-code">
                    <pre><%= row.output %></pre>
                  </td>
                  <td class="edgar-code">
                    <pre><%= row.expected %></pre>
                  </td>
                  <td class="edgar-code">
                    <pre><%= row.stderr %></pre>
                  </td>
                  <td class="edgar-code"><%= row.percentage%></td>
                  <td><%= row.hint %></td>
                  <td><%= row.isCorrect%></td>
                </tr>
                <% } %>
              </table>
            </details>
          </div>
          <% } %>
        </div>
        <div style="position: relative">
          <button class="btn-copy-to-clipobard">
            <i class="far fa-copy"></i>
          </button>
          <pre><code class="to-highlight"><%= qs[i].student_answer %></code></pre>
        </div>
      </div>
      <div class="col-sm-6 p-2 border border-deafult rounded">
        <div class="row">
          <div class="col-sm-12">
            <strong> Correct answer: </strong>
          </div>
        </div>
        <%- qs[i].correctHtml %>
      </div>
    </div>
    <div class="row answers-row">
      <div class="col-12 p-1 border border-deafult rounded">
        <%- qs[i].uploaded_files ? `
        <div class="d-flex flex-wrap" style="gap: 1rem">
          <a target="_blank" href="${qs[i].uploaded_files}" class="uploaded-files">
            <i class="file-icon fa fa-file"></i> Uploaded files</a
          >
        </div>
        ` : '' %>
      </div>
    </div>
    <div class="row bg-light">
      <div class="col-sm-6">
        <form action="/test/manualgrading/grade" method="POST">
          <input
            type="hidden"
            name="id_test_instance_question"
            value="<%-qs[i].id_test_instance_question%>"
          />
          <div class="form-row mt-3">
            <div class="form-group col-sm-6">
              <label for="score<%-i%>"
                >Score for <%= qs[i].alt_id2 %> <%= qs[i].last_name %>, <%= qs[i].first_name
                %></label
              >
            </div>
            <div class="col-sm-6 d-flex align-items-center justify-content-end">
              <h1><i class="fas fa-pencil-alt"></i></h1>
              <div title="Correct" class="badge badge-success border border-dark gm-label ml-4">
                <h4 class="m-0"><%= qs[i].grading_model_json.correct_score %><small>pts</small></h4>
                <small>Correct</small>
              </div>
              <div
                title="Unanswered"
                class="badge badge-secondary border border-dark ml-1 gm-label"
              >
                <h4 class="m-0">
                  <%= qs[i].grading_model_json.unanswered_score %> <small>pts</small>
                </h4>
                <small>Unanswered</small>
              </div>
              <div title="Incorrect" class="badge badge-danger border border-dark ml-1 gm-label">
                <h4 class="m-0">
                  <%= qs[i].grading_model_json.incorrect_score %> <small>pts</small>
                </h4>
                <small>Incorrect</small>
              </div>
            </div>
            <div class="form-group col-md-6 d-flex align-items-end">
              <input
                type="number"
                class="form-control"
                id="score<%-i%>"
                name="score"
                placeholder="Score"
                value="<%=qs[i].manual_score%>"
              />
              <button type="submit" class="ml-2 btn btn-primary btn-manual-score">Update</button>
            </div>
            <div class="form-group col-md-6 d-flex align-items-end">
              <span class="update-message" />
            </div>
          </div>
          <div class="form-group">
            <label for="comment">Comment (for student, to be shown in review)</label>
            <textarea
              class="form-control"
              id="comment<%-i%>"
              name="comment"
              rows="10"
              placeholder="comment"
            >
<%=qs[i].manual_comment%></textarea
            >
          </div>
        </form>
      </div>
      <% if(qs[i].grader_object) { %>
      <div class="col-sm-6">
        <div id="graderObjectContainer<%-i%>" class="container-fluid mt-3"></div>
      </div>
      <% } %>
    </div>
  </div>
  <br />
  <% } %>
</div>
<script
  src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.7.1/jszip.min.js"
  integrity="sha512-xQBQYt9UcgblF6aCMrwU1NkVA7HCXaSN2oq0so80KO+y68M+n64FOcqgav4igHe6D5ObBLIf68DWv+gfBowczg=="
  crossorigin="anonymous"
  referrerpolicy="no-referrer"
></script>
<script
  src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.24.0/axios.min.js"
  integrity="sha512-u9akINsQsAkG9xjc1cnGF4zw5TFDwkxuc9vUp5dltDWYCSmyd0meygbvgXrlc/z7/o4a19Fb5V0OUE58J7dcyw=="
  crossorigin="anonymous"
  referrerpolicy="no-referrer"
></script>
<script src="/js/app-teacher.js"></script>
<script type="text/javascript">
  <% for (var i = 0; i < qs.length; ++i) { %>
    <% if(qs[i].grader_object) { %>
      new edgar.Grader("graderObjectContainer<%-i%>", <%-qs[i].grader_object%>, "comment<%-i%>", <%-JSON.stringify(qs[i].grading_model_json)%>, "score<%-i%>");
    <% } %>
  <% } %>
    $('a.uploaded-files').each(function(idx, elem) {
        let url = $(elem).attr("href");
        axios.get(url, { responseType: 'arraybuffer' }).then((res) => {

            JSZip.loadAsync(new Blob([res.data], { type: 'application/zip' }))
                .then((zip) => {
                    const zipObj = zip;
                    $.each(zip.files, function (index, zipEntry) {
                        if (zipEntry.name.toLowerCase().endsWith('.png') ||
                            zipEntry.name.toLowerCase().endsWith('.jpg')) {
                            zipObj.file(zipEntry.name).async('blob')
                                .then((blob) => {
                                    var blobUrl = URL.createObjectURL(blob);
                                    let item = '<div class="mg-file border border-secondary rounded"><span style="opacity: 80%" class="badge badge-info mg-file-label">' +zipEntry.name + '</span>'
                                             + '<img class="inline-image" style="max-width: 90vw;" title="' + zipEntry.name + '" src="' + blobUrl + '" />'
                                             + '</div>';
                                    $(elem).after(item);
                                });
                        } else if (zipEntry.name.toLowerCase().endsWith('.docx')
                            || zipEntry.name.toLowerCase().endsWith('.docx')
                            || zipEntry.name.toLowerCase().endsWith('.pptx')
                            || zipEntry.name.toLowerCase().endsWith('.ppt')
                            || zipEntry.name.toLowerCase().endsWith('.xls')
                            || zipEntry.name.toLowerCase().endsWith('.xlsx')
                            ) {
                            let path = url.split('/').pop
                            let myurl = window.location.origin + "/fromzip/" + zipEntry.name + "?zip=" + url;
                            myurl = encodeURIComponent(myurl);
                            let item = '<div class="mg-file border border-secondary rounded"><span  style="opacity: 80%" class="badge badge-info mg-file-label">' +zipEntry.name + ')</span>'
                                + '<iframe class="inline-doc" src="https://view.officeapps.live.com/op/view.aspx?src=' + myurl + '" width="900px" height="1200px" frameborder="0"></iframe>'
                                + '</div>';
                            $(elem).after(item);
                        } else if (zipEntry.name.toLowerCase().endsWith('.pdf')
                            ) {
                            let path = url.split('/').pop
                            let myurl = window.location.origin + "/fromzip/" + zipEntry.name + "?zip=" + url;
                            myurl = encodeURIComponent(myurl);
                            console.log(myurl);
                            let item = '<div class="mg-file border border-secondary rounded"><span style="opacity: 80%" class="badge badge-info mg-file-label">' +zipEntry.name + ')</span>'
                                + '<iframe class="inline-doc" src="https://docs.google.com/viewer?url=' + myurl + '&embedded=true" style="width:900px; height:1200px;" frameborder="0"></iframe>'
                                + '</div>';
                            $(elem).after(item);
                        } else if (zipEntry.name.toLowerCase().endsWith('.zip')) {
                            zipObj.file(zipEntry.name).async('blob')
                                .then((nestedzipblob) => {
                                    return JSZip.loadAsync(nestedzipblob, { type: 'application/zip' });
                                })
                                .then((nestedzip) => {
                                    $.each(nestedzip.files, function (index, nestedZipEntry){
                                        if (nestedZipEntry.name.toLowerCase().endsWith('.png') ||
                                        nestedZipEntry.name.toLowerCase().endsWith('.jpg')) {
                                            nestedzip.file(nestedZipEntry.name).async('blob')
                                                .then((blob) => {
                                                    var blobUrl = URL.createObjectURL(blob);
                                                    let item = '<div class="mg-file border border-secondary rounded"><span style="opacity: 80%" class="badge badge-info mg-file-label">From nested zip: ' +zipEntry.name + '</span>'
                                                    + '<img class="inline-image" style="max-width: 90vw;" title="' + zipEntry.name + '" src="' + blobUrl + '" />'
                                                    + '</div>';
                                                     $(elem).after(item);
                                                });
                                        }
                                    });
                                });
                        }
                    });
                    return zip;

                }).then((zip)=> {
                    $(elem).append('<span class="ml-3 text-info">('+ Object.keys(zip.files).join(', ') + ')</span>');
                });
        });
    });

    $('button.btn-manual-score').click(function(e) {
        var btn = $(this);
        e.preventDefault();
        var form = btn.closest("form");
        var formData = form.serializeArray();

        $.ajax({
            type: form.attr('method'),
            url: form.attr('action'),
            data: formData
        }).always(function (data, textStatus, errorThrown) {
            if (data.success) {
                form = $(form);
                data = data.data;
                form.find('[name="score"]').val(data.score);
                form.find('[name="score"]').removeClass('bg-orange');
                form.find('[name="comment"]').val(data.comment);
                form.find(".update-message").html('Updated at ' + data.ts_modified);
                form.find(".update-message").addClass("bg-success");
            } else {
                edgar.showInfoDialog(JSON.stringify(data), undefined, "Update failed :-(");
            }
        });
        return false;
    });
    $('button.btn-toggle-answers').click(function(e) {
        var btn = $(this);
        if (btn.hasClass('expanded')) {
            $('.correct-answers-row').each(function(idx, elem) {
                let rows = $(elem).children();
                rows.first().removeClass('col-sm-12').addClass('col-sm-6');
                rows.last().removeClass('d-none').addClass('col-sm-6');
            });
            btn.removeClass('expanded');
        } else {
             $('.correct-answers-row').each(function(idx, elem) {
                let rows = $(elem).children();
                rows.first().removeClass('col-sm-6').addClass('col-sm-12');
                rows.last().removeClass('col-sm-6').addClass('d-none');
             });
            btn.addClass('expanded');
        }
        e.preventDefault();
        return false;
    });
    $('button.btn-toggle-questions').click(function(e) {
        var btn = $(this);
        if (btn.hasClass('invsbl')) {
            $('.question-row').show();
            btn.removeClass('invsbl');
        } else {
            $('.question-row').hide();
            btn.addClass('invsbl');
        }
        e.preventDefault();
        return false;
    });
    $('button.btn-toggle-images').click(function(e) {
        var btn = $(this);
        if (btn.hasClass('invsbl')) {
            $('img.inline-image').show();
            btn.removeClass('invsbl');
        } else {
            $('img.inline-image').hide();
            btn.addClass('invsbl');
        }
        e.preventDefault();
        return false;
    });
    $('button.btn-toggle-docs').click(function(e) {
        var btn = $(this);
        if (btn.hasClass('invsbl')) {
            $('iframe.inline-doc').show();
            btn.removeClass('invsbl');
        } else {
            $('iframe.inline-doc').hide();
            btn.addClass('invsbl');
        }
        e.preventDefault();
        return false;
    });
    $('button.btn-hide-graded').click(function(e) {
        var btn = $(this);
        $("input[name='score']").filter(function () {
            return this.value.length > 0
        }).closest('.question-bundle').addClass("d-none");
        e.preventDefault();
        return false;
    });
    $('button.btn-copy-to-clipobard').click(function(e) {
        e.preventDefault();
        var btn = $(this);
        edgar.copyToClipboard(btn.closest('div').text());
        return false;
    });
</script>
